%%
% Matlab code used to analyze the data. If you would like to use this code
% please contact efreud@yorku.ca for more instructions 
%%
clear all
load '/Users/erezfreud/Dropbox/PostDoc/Parametric_scrambling_RSA/RSA_Dorsal_Cortex/new bins/SMvoxel_analysis/controls.mat'
load '/Users/erezfreud/Dropbox/PostDoc/Parametric_scrambling_RSA/RSA_Dorsal_Cortex/new bins/SMvoxel_analysis/SM1.mat'
load '/Users/erezfreud/Dropbox/PostDoc/Parametric_scrambling_RSA/RSA_Dorsal_Cortex/new bins/SMvoxel_analysis/SM2.mat'
SM1=SM1(2:end,:);%2018
SM2=SM2(2:end,:);%2016
allpathway_controls=allpathway_controls(2:end,:,:);
allpathway_controls_avg=mean(allpathway_controls,3);
allpathway_cotnrols_std=std(allpathway_controls,0,3);

%define N ROIs based on coordiantes - kmeans (Aug 2019)
clear tSM_ROI
clear ROIanalysis
kmeanvalue=120;
% to compute the kmeans :
% [idx4,cent4,sumdist] = kmeans(allpathway_controls_avg(:,1:3),kmeanvalue,'Distance','cityblock',...
%                        'Display','final','Replicates',200);
load(['/Users/erezfreud/Dropbox/postdoc/Parametric_scrambling_RSA/RSA_Dorsal_Cortex/new bins/SMvoxel_analysis/kmeans_clusters/' num2str(kmeanvalue) 'ROIs.mat'])
allpathway_controls_avg(:,5)=idx4;%clusters (80/100/120, based on location)
for i=1:kmeanvalue
ROIanalysis(1:15,i)=squeeze(squeeze(mean(allpathway_controls(allpathway_controls_avg(:,5)==i,4,:),1)))
ROIanalysis(16,i)=squeeze(mean(SM1(allpathway_controls_avg(:,5)==i,4),1));
ROIanalysis(17,i)=squeeze(mean(SM2(allpathway_controls_avg(:,5)==i,4),1));
% ROIanalysis(18,i)=squeeze(mean(TCK2016(allpathway_controls_avg(:,5)==i,4),1));
% ROIanalysis(19,i)=squeeze(mean(TCK2019(allpathway_controls_avg(:,5)==i,4),1));
% ROIanalysis(20,i)=squeeze(mean(SK2016(allpathway_controls_avg(:,5)==i,4),1));
% ROIanalysis(21,i)=squeeze(mean(SK2019(allpathway_controls_avg(:,5)==i,4),1));
ROIanalysis(18,i)=squeeze(mean(allpathway_controls_avg(allpathway_controls_avg(:,5)==i,1),1));%x coordiante
ROIanalysis(19,i)=squeeze(mean(allpathway_controls_avg(allpathway_controls_avg(:,5)==i,2),1));%y coordiante
ROIanalysis(20,i)=squeeze(mean(allpathway_controls_avg(allpathway_controls_avg(:,5)==i,3),1));%z coordiante

tSM_ROI(1,i)=(ROIanalysis(16,i)-mean(ROIanalysis(1:15,i)))/(std(ROIanalysis(1:15,i))*sqrt(16/15));%comapre SM to controls
tSM_ROI(2,i)=(ROIanalysis(17,i)-mean(ROIanalysis(1:15,i)))/(std(ROIanalysis(1:15,i))*sqrt(16/15));%comapre SM to controls
tSM_ROI(3,i)= (ROIanalysis(16,i)-ROIanalysis(17,i))/(sqrt(2*std(ROIanalysis(1:15,i))^2));%comapre SM1 to SM2 --> dif / sqrt(2*stdev of controls^2)

    for s=1:15 %test if controls also deviates
    temp_avg=mean(ROIanalysis(1:15 ~=s,i));
    temp_std=std(ROIanalysis(1:15 ~=s,i));
    tSubj(s,i)=(ROIanalysis(s,i)-temp_avg)/(temp_std*sqrt(15/14));
    end
end

SM2(:,5)=0;

%clusters that are lower in SM (based on tSM_ROI
index_positive=find(mean(tSM_ROI(1:2,:))>2.13);%SM>CONTROL
index_negative=find(mean(tSM_ROI(1:2,:))<-2.13); %SM<CONTROL

index_positive_withSM=find(tSM_ROI(3,:)>2.13);
index_negative_withSM=find(tSM_ROI(3,:)>2.13);

for y=1:length(index_positive)
SM2(allpathway_controls_avg(:,5)==index_positive(y),5)=1; % t-test sig / not-sig
SM2(allpathway_controls_avg(:,5)==index_positive(y),6)=mean(ROIanalysis(1:15,index_positive(y))); % avg. ROI sensitivity
SM2(allpathway_controls_avg(:,5)==index_positive(y),7)=mean(tSM_ROI(1:2,index_positive(y))); % t score with SM
SM2(allpathway_controls_avg(:,5)==index_positive(y),8)=(mean(ROIanalysis(1:15,index_positive(y)))-mean(ROIanalysis(16:17,index_positive(y)))); % dif-score


end
for y=1:length(index_negative)
SM2(allpathway_controls_avg(:,5)==index_negative(y),5)=-1;
SM2(allpathway_controls_avg(:,5)==index_negative(y),6)=mean(ROIanalysis(1:15,index_negative(y))); % avg. ROI sensitivity
SM2(allpathway_controls_avg(:,5)==index_negative(y),7)=mean(tSM_ROI(1:2,index_negative(y))); % t score with SM
SM2(allpathway_controls_avg(:,5)==index_negative(y),8)=(mean(ROIanalysis(1:15,index_negative(y)))-mean(ROIanalysis(16:17,index_negative(y)))); % dif-score

end


[index_positive_controls(:,1),index_positive_controls(:,2)]=find(tSubj>2.14);
[index_negative_controls(:,1),index_negative_controls(:,2)]=find(tSubj<-2.14);
%calcuate divatation of controls from the mean
colorControls=zeros(5624,3,15);
colorControls(:,2,:)=1;
for r=1:15
    temp_ind_pos=index_positive_controls(index_positive_controls(:,1)==r,:);
    sig_cluster(r,1)=length(temp_ind_pos(:,1));
    for y=1:length(temp_ind_pos(:,1))
    colorControls(allpathway_controls_avg(:,5)==temp_ind_pos(y,2),1,r)=1;
    colorControls(allpathway_controls_avg(:,5)==temp_ind_pos(y,2),2,r)=0;
    %colorControls(allpathway_controls_avg(:,5)==temp_ind_pos(y),3,r)=0;
    end

    temp_ind_neg=index_negative_controls(index_negative_controls(:,1)==r,:);
    sig_cluster(r,2)=length(temp_ind_neg(:,1)); %to compare between the number of positive/negative clusters in controls vs. SM
    
    for y=1:length(temp_ind_neg(:,1))
    colorControls(allpathway_controls_avg(:,5)==temp_ind_neg(y,2),3,r)=1;
    colorControls(allpathway_controls_avg(:,5)==temp_ind_neg(y,2),2,r)=0;

    end
end

sig_cluster(16,1:2)=[length(index_positive),length(index_negative)];
%%
figure (1)
SM2(and(SM2(:,6)>0,SM2(:,7)>0),9)=SM2(and(SM2(:,6)>0,SM2(:,7)>0),8); % positive slope / sm > control
SM2(and(SM2(:,6)<0,SM2(:,7)>0),10)=SM2(and(SM2(:,6)<0,SM2(:,7)>0),8); % negative slope / sm > control
SM2(and(SM2(:,6)>0,SM2(:,7)<0),11)=SM2(and(SM2(:,6)>0,SM2(:,7)<0),8); % positive slope / sm < control
SM2(and(SM2(:,6)<0,SM2(:,7)<0),12)=SM2(and(SM2(:,6)<0,SM2(:,7)<0),8); % negative slope / sm < control
SM2(or(SM2(:,9)~=0,SM2(:,11)~=0),13)=SM2(or(SM2(:,9)~=0,SM2(:,11)~=0),8);%poitive slope
SM2(or(SM2(:,10)~=0,SM2(:,12)~=0),14)=SM2(or(SM2(:,10)~=0,SM2(:,12)~=0),8);%negative slope

for x=1:6
subplot(3,2,x)
% Scatter3, size 5, color based on zz
scatter3(SM1(:,1),SM1(:,2),SM1(:,3),15,SM2(:,x+8),'filled');
% colomap and bar
colormap(jet);
xlabel('Left - Right')
ylabel('Posterior - Anterior')
zlabel('inferior - Superior')
title(num2str(x))
view(38,30)
colorbar
caxis([-0.15 0.15])

end


%%

figure(2)
% Scatter3, size 5, color based on zz
scatter3(SM1(:,1),SM1(:,2),SM1(:,3),15,allpathway_controls_avg(:,5),'filled');
% colomap and bar
colormap(colorcube);
xlabel('Left - Right')
ylabel('Posterior - Anterior')
zlabel('inferior - Superior')
title('ROIs')
view(38,30)

%
figure (3)
for s=1:15
    subplot(2,8,s)
    scatter3(SM1(:,1),SM1(:,2),SM1(:,3),15,colorControls(:,:,s),'filled');
    % colomap and bar
    colormap(jet);
    xlabel('Left - Right')
    ylabel('Posterior - Anterior')
    zlabel('inferior - Superior')
    title('controls')
    view(38,30)

   
end








%%
%inter-correlations-between-subjects
%first column - controls then 2 SM scans , then next pathway.
for i = 1:15
   %whole brain
    between_subj(i,1)=corr(ROIanalysis(i,:)',mean(ROIanalysis([1:i-1 i+1:15],:),1)')
    between_subj(i,2)=corr(ROIanalysis(16,:)',mean(ROIanalysis([1:i-1 i+1:15],:),1)')
    between_subj(i,3)=corr(ROIanalysis(17,:)',mean(ROIanalysis([1:i-1 i+1:15],:),1)')
    
    
    %Left hemisphere
    between_subj(i,4)=corr(ROIanalysis(i,ROIanalysis(18,:)<0)',mean(ROIanalysis([1:i-1 i+1:15],ROIanalysis(18,:)<0),1)')
    between_subj(i,5)=corr(ROIanalysis(16,ROIanalysis(18,:)<0)',mean(ROIanalysis([1:i-1 i+1:15],ROIanalysis(18,:)<0),1)')
    between_subj(i,6)=corr(ROIanalysis(17,ROIanalysis(18,:)<0)',mean(ROIanalysis([1:i-1 i+1:15],ROIanalysis(18,:)<0),1)')
    
    %dorsal pathway
     between_subj(i,7)=corr(ROIanalysis(i,ROIanalysis(20,:)>0)',mean(ROIanalysis([1:i-1 i+1:15],ROIanalysis(20,:)>0),1)')
    between_subj(i,8)=corr(ROIanalysis(16,ROIanalysis(20,:)>0)',mean(ROIanalysis([1:i-1 i+1:15],ROIanalysis(20,:)>0),1)')
    between_subj(i,9)=corr(ROIanalysis(17,ROIanalysis(20,:)>0)',mean(ROIanalysis([1:i-1 i+1:15],ROIanalysis(20,:)>0),1)')
    
    
 
   %right ventral
    between_subj_hemi(i,1)=corr(ROIanalysis(i,ROIanalysis(18,:)>0 & ROIanalysis(20,:)<0)',mean(ROIanalysis([1:i-1 i+1:15],ROIanalysis(18,:)>0 & ROIanalysis(20,:)<0),1)')
    between_subj_hemi(i,2)=corr(ROIanalysis(16,ROIanalysis(18,:)>0 & ROIanalysis(20,:)<0)',mean(ROIanalysis([1:i-1 i+1:15],ROIanalysis(18,:)>0 & ROIanalysis(20,:)<0),1)')
    between_subj_hemi(i,3)=corr(ROIanalysis(17,ROIanalysis(18,:)>0 & ROIanalysis(20,:)<0)',mean(ROIanalysis([1:i-1 i+1:15],ROIanalysis(18,:)>0 & ROIanalysis(20,:)<0),1)')  
   
   %left ventral
    between_subj_hemi(i,4)=corr(ROIanalysis(i,ROIanalysis(18,:)<0 & ROIanalysis(20,:)<0)',mean(ROIanalysis([1:i-1 i+1:15],ROIanalysis(18,:)<0 & ROIanalysis(20,:)<0),1)')
    between_subj_hemi(i,5)=corr(ROIanalysis(16,ROIanalysis(18,:)<0 & ROIanalysis(20,:)<0)',mean(ROIanalysis([1:i-1 i+1:15],ROIanalysis(18,:)<0 & ROIanalysis(20,:)<0),1)')
    between_subj_hemi(i,6)=corr(ROIanalysis(17,ROIanalysis(18,:)<0 & ROIanalysis(20,:)<0)',mean(ROIanalysis([1:i-1 i+1:15],ROIanalysis(18,:)<0 & ROIanalysis(20,:)<0),1)')  
   
   %right dorsal
    between_subj_hemi(i,7)=corr(ROIanalysis(i,ROIanalysis(18,:)>0 & ROIanalysis(20,:)>0)',mean(ROIanalysis([1:i-1 i+1:15],ROIanalysis(18,:)>0 & ROIanalysis(20,:)>0),1)')
    between_subj_hemi(i,8)=corr(ROIanalysis(16,ROIanalysis(18,:)>0 & ROIanalysis(20,:)>0)',mean(ROIanalysis([1:i-1 i+1:15],ROIanalysis(18,:)>0 & ROIanalysis(20,:)>0),1)')
    between_subj_hemi(i,9)=corr(ROIanalysis(17,ROIanalysis(18,:)>0 & ROIanalysis(20,:)>0)',mean(ROIanalysis([1:i-1 i+1:15],ROIanalysis(18,:)>0 & ROIanalysis(20,:)>0),1)')  
   
   %left dorsal
    between_subj_hemi(i,10)=corr(ROIanalysis(i,ROIanalysis(18,:)<0 & ROIanalysis(20,:)>0)',mean(ROIanalysis([1:i-1 i+1:15],ROIanalysis(18,:)<0 & ROIanalysis(20,:)>0),1)')
    between_subj_hemi(i,11)=corr(ROIanalysis(16,ROIanalysis(18,:)<0 & ROIanalysis(20,:)>0)',mean(ROIanalysis([1:i-1 i+1:15],ROIanalysis(18,:)<0 & ROIanalysis(20,:)>0),1)')
    between_subj_hemi(i,12)=corr(ROIanalysis(17,ROIanalysis(18,:)<0 & ROIanalysis(20,:)>0)',mean(ROIanalysis([1:i-1 i+1:15],ROIanalysis(18,:)<0 & ROIanalysis(20,:)>0),1)')  
   
      
    
end
subplot(2,2,1)
scatter(ROIanalysis(16,ROIanalysis(18,:)>0 & ROIanalysis(20,:)<0)',mean(ROIanalysis([1:i-1 i+1:15],ROIanalysis(18,:)>0 & ROIanalysis(20,:)<0),1)')
slopeVR=polyfit(ROIanalysis(16,ROIanalysis(18,:)>0 & ROIanalysis(20,:)<0)',mean(ROIanalysis([1:i-1 i+1:15],ROIanalysis(18,:)>0 & ROIanalysis(20,:)<0),1)',1)

subplot(2,2,2)
scatter(ROIanalysis(16,ROIanalysis(18,:)<0 & ROIanalysis(20,:)<0)',mean(ROIanalysis([1:i-1 i+1:15],ROIanalysis(18,:)<0 & ROIanalysis(20,:)<0),1)')
slopeVL=polyfit(ROIanalysis(16,ROIanalysis(18,:)<0 & ROIanalysis(20,:)<0)',mean(ROIanalysis([1:i-1 i+1:15],ROIanalysis(18,:)<0 & ROIanalysis(20,:)<0),1)',1)

subplot(2,2,3)
scatter(ROIanalysis(16,ROIanalysis(18,:)>0 & ROIanalysis(20,:)>0)',mean(ROIanalysis([1:i-1 i+1:15],ROIanalysis(18,:)>0 & ROIanalysis(20,:)>0),1)')
slopeDR=polyfit(ROIanalysis(16,ROIanalysis(18,:)>0 & ROIanalysis(20,:)>0)',mean(ROIanalysis([1:i-1 i+1:15],ROIanalysis(18,:)>0 & ROIanalysis(20,:)>0),1)',1)

subplot(2,2,4)
scatter(ROIanalysis(16,ROIanalysis(18,:)<0 & ROIanalysis(20,:)>0)',mean(ROIanalysis([1:i-1 i+1:15],ROIanalysis(18,:)<0 & ROIanalysis(20,:)>0),1)')
slopeDL=polyfit(ROIanalysis(16,ROIanalysis(18,:)<0 & ROIanalysis(20,:)>0)',mean(ROIanalysis([1:i-1 i+1:15],ROIanalysis(18,:)<0 & ROIanalysis(20,:)>0),1)',1)



%%
